package org.zeroconf;

import java.net.*;

import com.apple.dnssd.*;

import org.gudy.azureus2.plugins.download.Download;
import org.gudy.azureus2.plugins.peers.PeerManager;

public class PeerAdder implements QueryListener {

	PeerManager pm;
	int port;
	
	public PeerAdder(Download download, int port) {
		pm = download.getPeerManager();
		this.port = port;
	}
	
	//Query callback 
	public void	queryAnswered( DNSSDService query, int flags, int ifIndex, String fullName,
									int rrtype, int rrclass, byte[] rdata, int ttl) {
		try { //debug
			if(pm != null) {
					System.out.println("Query returned IP: " + InetAddress.getByAddress(rdata).getHostAddress() );
					pm.addPeer(InetAddress.getByAddress( rdata).getHostAddress(), port);
			}
		}
		catch (Exception e) {
			System.out.println("Failed to add peer");
		}
			
	}
	
	//DNSSD Common callback	
	public void	operationFailed( DNSSDService service, int errorCode) {
		System.err.println( "PeerAdder Query Service reported error " + String.valueOf( errorCode));
	}
}
