package org.zeroconf;

import java.util.HashMap;

import org.gudy.azureus2.plugins.*;
import org.gudy.azureus2.plugins.PluginInterface;
import org.gudy.azureus2.plugins.download.Download;
import org.gudy.azureus2.plugins.download.DownloadListener;
import org.gudy.azureus2.plugins.download.DownloadManagerListener;
import org.gudy.azureus2.plugins.logging.LoggerChannel;

import com.apple.dnssd.*;


public class Plugin implements org.gudy.azureus2.plugins.UnloadablePlugin, DownloadManagerListener, DownloadListener  {

	
	//Plugin interface which gives access to the Azureus plugin API
	public PluginInterface pluginInterface;
	
	static public LoggerChannel logger;
	
	HashMap<Download, Advertisement> allAds = new HashMap<Download, Advertisement>();
	HashMap<Download, Discovery> allDiscovers = new HashMap<Download, Discovery>();
 	
	//UnloadablePlugin
	public void unload() throws PluginException {
	//	advert.stop();
	}
		
	public void initialize(PluginInterface pluginIf) throws PluginException {
	
		this.pluginInterface = pluginIf;
		// create a listener on starting, stopping and current downloads
        pluginInterface.getDownloadManager().addListener(this, true);
		
		logger = this.pluginInterface.getLogger().getTimeStampedChannel(this.pluginInterface.getPluginID());
	}
	
	//Download Manager Listener	
	public void downloadAdded(Download download) {
		download.addListener(Plugin.this);
	}
	
	//Download Manager Listener	
	public void downloadRemoved(Download download) {
		
	}
	
	//Download Listener
	public void positionChanged(Download download, int old_position, int new_position) {
		// not used
	}

	//Download Listener	
	public void stateChanged(Download download, int old_state, int new_state) {
		if (new_state == Download.ST_SEEDING || new_state == Download.ST_DOWNLOADING) {
			logger.log("Advertising torrent: " + download.getName() );

			try {
				allAds.put(download, new Advertisement(download, pluginInterface, logger));
				allDiscovers.put(download, new Discovery(download, logger));
			}
			catch (Exception e) {
				e.printStackTrace();
			}
		}
		else if (new_state == Download.ST_STOPPED) {
				logger.log("Stopped download: " + download.getName());
				allAds.get(download).stop();
				allDiscovers.get(download).stop();
		}
	}
}


